<script setup lang="ts">
import ConfirmModal from '@/components/ConfirmModal.vue'
import FormModal from '@/components/FormModal.vue'
import { useChansonStore } from '@/stores/chanson'
import { useTagStore } from '@/stores/tag'
import type { ChansonDeezer } from '@/types/chansonDto'
import type FormFields from '@/types/formFields'
import {
  ChevronDownIcon,
  ChevronUpDownIcon,
  ChevronUpIcon,
  PlusSmallIcon,
  XMarkIcon
} from '@heroicons/vue/24/solid'
import { ref, watch, type Ref } from 'vue'
import * as yup from 'yup'

const chansonStore = useChansonStore()
const tagStore = useTagStore()

// Tri de la table
// ========================
type sort = 'up' | 'down'
const sortButtonClasses = 'max-h-6 min-h-6 cursor-pointer'

const tags = tagStore.tagsAsMap
const chansons = ref(chansonStore.chansons)
const contentChansons = ref([...chansons.value])

let sortOrderTitre: Ref<sort | undefined> = ref(undefined)
let sortOrderArtiste: Ref<sort | undefined> = ref(undefined)
let sortOrderValeurTag: Ref<sort | undefined> = ref(undefined)

function sortProperty(pRef: Ref<sort | undefined>) {
  if (pRef.value === undefined) {
    pRef.value = 'up'
  } else if (pRef.value === 'up') {
    pRef.value = 'down'
  } else {
    pRef.value = undefined
  }
}

const sortTitre = () => sortProperty(sortOrderTitre)
const sortArtiste = () => sortProperty(sortOrderArtiste)
const sortValeurTag = () => sortProperty(sortOrderValeurTag)

let isSorting = false

const mapping = [
  {
    property: sortOrderTitre,
    toReset: [sortOrderArtiste, sortOrderValeurTag],
    toCompare: (c: ChansonDeezer) => c.titre
  },
  {
    property: sortOrderArtiste,
    toReset: [sortOrderTitre, sortOrderValeurTag],
    toCompare: (c: ChansonDeezer) => c.artiste.nom
  },
  {
    property: sortOrderValeurTag,
    toReset: [sortOrderTitre, sortOrderArtiste],
    toCompare: (c: ChansonDeezer) => tags.get(c.valeursTags[0]?.tag ?? -1)?.nom ?? ''
  }
]

watch([sortOrderTitre, sortOrderArtiste, sortOrderValeurTag], (next, previous) => {
  // Bloque le redéclenchement des évènements
  if (!isSorting) {
    isSorting = true

    // Détecte qui a été modifié, sur les 3 propriétés
    const uniqueSort = next.map((e, i) => {
      const ep = previous[i]
      if (e === ep) return undefined
      else return e
    })

    // Si aucun tri, on affiche les données d'origine
    if (uniqueSort.every((e) => e === undefined)) {
      contentChansons.value = [...chansons.value]
    } else {
      // Sinon, on trie par l'ordre de tri demandé
      const definedSortIndex = uniqueSort.findIndex((s) => s !== undefined)
      const definedSort = uniqueSort.find((s) => s !== undefined)!!
      const m = mapping[definedSortIndex]

      m.toReset.forEach((p) => (p.value = undefined))

      sortTable(definedSort, m.toCompare)
    }

    setTimeout(() => {
      isSorting = false
    }, 150) // on empêche d'autres évènements de "watch" de se passer, en débloquant ce flag un peu après la fin du bloc de code
  }
})

function sortTable(definedSort: sort, propertyToCompare: (c: ChansonDeezer) => string) {
  let sortOrder: number
  if (definedSort === 'up') sortOrder = 1
  else sortOrder = -1

  contentChansons.value = [...chansons.value].sort(
    (a, b) => sortOrder * propertyToCompare(a).localeCompare(propertyToCompare(b))
  )
}

// Gestion des valeurs de tags
// ==================================
watch(chansons, (next) => {
  let sortOrder: sort
  let sortProperty: (c: ChansonDeezer) => string

  if (sortOrderTitre.value) {
    sortOrder = sortOrderTitre.value
    sortProperty = mapping[0].toCompare
  } else if (sortOrderArtiste.value) {
    sortOrder = sortOrderArtiste.value
    sortProperty = mapping[1].toCompare
  } else if (sortOrderValeurTag.value) {
    sortOrder = sortOrderValeurTag.value
    sortProperty = mapping[2].toCompare
  } else {
    contentChansons.value = [...next]
    return
  }

  sortTable(sortOrder, sortProperty)
})

const valeurTagSchema: FormFields = {
  fields: [
    {
      label: 'Tag',
      name: 'idTag',
      as: 'select',
      children: tagStore.tags.map((t) => {
        return { tag: 'option', value: t.id, text: t.nom }
      })
    },
    {
      label: 'Valeur',
      name: 'valeur',
      as: 'input',
      rules: yup
        .string()
        .required()
        .min(1)
        .matches(/^(\S|((?!.*\s{2})\S.*\S)?)$/)
    }
  ]
}

async function addValeurTag(idChanson: number, p: { idTag: number; valeur: string }) {
  await chansonStore.addValeurTag(idChanson, p.idTag, p.valeur)
  await chansonStore.loadAll()

  chansons.value = chansonStore.chansons
}
</script>

<template>
  <table class="table max-xs:table-xs table-pin-rows">
    <thead>
      <tr>
        <th></th>
        <th>
          <div class="flex items-center" @click="sortTitre">
            Titre
            <div class="contents">
              <ChevronUpIcon v-if="sortOrderTitre === 'up'" :class="sortButtonClasses" />
              <ChevronDownIcon v-if="sortOrderTitre === 'down'" :class="sortButtonClasses" />
              <ChevronUpDownIcon v-if="sortOrderTitre === undefined" :class="sortButtonClasses" />
            </div>
          </div>
        </th>
        <th>
          <div class="flex items-center">
            Artiste(s)
            <div class="contents" @click="sortArtiste">
              <ChevronUpIcon v-if="sortOrderArtiste === 'up'" :class="sortButtonClasses" />
              <ChevronDownIcon v-if="sortOrderArtiste === 'down'" :class="sortButtonClasses" />
              <ChevronUpDownIcon v-if="sortOrderArtiste === undefined" :class="sortButtonClasses" />
            </div>
          </div>
        </th>
        <th>
          <div class="flex items-center">
            Valeur des tags
            <div class="contents" @click="sortValeurTag">
              <ChevronUpIcon v-if="sortOrderValeurTag === 'up'" :class="sortButtonClasses" />
              <ChevronDownIcon v-if="sortOrderValeurTag === 'down'" :class="sortButtonClasses" />
              <ChevronUpDownIcon
                v-if="sortOrderValeurTag === undefined"
                :class="sortButtonClasses"
              />
            </div>
          </div>
        </th>
        <th>Extrait</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="chanson in contentChansons" :key="chanson.id" class="hover">
        <td>
          <label><input type="checkbox" class="checkbox" /></label>
        </td>
        <td>{{ chanson.titre }}</td>
        <td>{{ chanson.artiste.nom }}</td>

        <td>
          <div class="flex flex-wrap gap-1">
            <div
              class="badge max-xs:badge-xs p-2 badge-outline whitespace-nowrap"
              v-for="(valeurTag, index) in chanson.valeursTags"
              :key="index"
            >
              {{ tags.get(valeurTag.tag)?.nom + ': ' + valeurTag.valeur }}
              <ConfirmModal
                title="Suppression de la valeur du tag"
                :message="`Êtes-vous sûr de vouloir supprimer la valeur de tag pour le tag '${
                  tags.get(valeurTag.tag)?.nom
                }' ?`"
                modal-type="yesNo"
                :on-action="() => chansonStore.deleteValeurTag(chanson.id, valeurTag.tag)"
              >
                <XMarkIcon
                  class="ml-2 w-4 cursor-pointer hover:fill-error active:fill-error-content"
                />
              </ConfirmModal>
            </div>
            <div class="badge max-xs:badge-xs hover:badge-success active:bg-success-content">
              <FormModal
                title="Ajout d'une valeur de tag"
                :schema="valeurTagSchema"
                :on-action="(p) => addValeurTag(chanson.id, p)"
                yes-button-label="Ajouter"
                no-button-label="Annuler"
              >
                <PlusSmallIcon class="w-4" />
              </FormModal>
            </div>
          </div>
        </td>

        <td><a :href="chanson.extrait" class="link">Extrait</a></td>
      </tr>
    </tbody>
  </table>
</template>
